package org.greenstone.gsdl3.gs3build.util;

public class HTMLContext
{ boolean valid;
	StringBuffer	text;
	
	public static	HTMLTagVector breakTags = new HTMLTagVector("a,h1,h2,h3,h4,h5,h6,table,hr,p,ul,ol,dl,dt,dd,li,tr,td,th,map");

	private int offset (String string, int direction)
	{	int offset;

		if (direction > 0)
		{	offset = string.indexOf('.');
		}
		else
		{	offset = string.lastIndexOf('.');
		}
		return offset;
	}

	public HTMLContext(HTMLBlock parent, HTMLBlock child, int scope)
	{ int pos;
		int start, startoffset;
		int	end, endoffset;
		int	length;
		String	string;
		HTMLTag	tag;

		this.text	= null;

		// if we can't match it, give up!
		pos = parent.find(child);
		if (pos < 0)
		{ this.valid	= false;
			return;
		}

		// get start!
		if (pos > 0)
		{ start = pos - 1;
		}
		else
		{	start	= 0;
		}	
		startoffset	= -1;
		length	= 0;
		while (	start > 0)
		{	
		  /*
		  if (parent.elementAt(start) instanceof String)
			{	string = (String) parent.elementAt(start);

				startoffset	= offset(string, -1);
				if (startoffset > 0)
				{	break;
				}

				length += string.length();
				
				if (length >= scope)
				{	break;
				}
				}
				else 
		  */
			if (parent.elementAt(start) instanceof HTMLCText)
			{	string = ((HTMLCText) parent.elementAt(start)).toString();

				startoffset	= offset(string, -1);
				if (startoffset > 0)
				{	break;
				}

				length += string.length();

				if (length >= scope)
				{	break;
				}
			}
			else if (parent.elementAt(start) instanceof HTMLTag)
			{	// do some checks
				tag = (HTMLTag) parent.elementAt(start);

				if (breakTags.matches(tag, false))
				{	startoffset	= -1;
					break;
				}
			}
			start --;
		}

		// get end!
		pos = pos + child.size();
		if (pos < parent.size())
		{ end	= pos + 1;
		}
		else
		{	end	= parent.size();
		}	
		endoffset	= -1;
		length	= 0;
		string	= null;
		while (end < parent.size())
		{	if (parent.content.elementAt(start) instanceof String)
			{	string = (String) parent.content.elementAt(start);

				endoffset	= offset(string, +1);
				if (endoffset >= 0)
				{	break;
				}

				length += string.length();

				if (length >= scope)
				{	break;
				}
			}
			else if (parent.content.elementAt(start) instanceof HTMLCText)
			{	string = ((HTMLCText) parent.content.elementAt(start)).toString();

				endoffset	= offset(string, +1);
				if (endoffset >= 0)
				{	break;
				}

				length += string.length();

				if (length >= scope)
				{	break;
				}
			}
			else if (parent.content.elementAt(start) instanceof HTMLTag)
			{	tag = (HTMLTag) parent.elementAt(start);

				if (breakTags.matches(tag, false))
				{	endoffset	= -1;
					end	= end - 1;
					break;
				}
			}
			System.out.println("String:"+string);
			end ++;
		}

		this.text	= new StringBuffer();
		if (startoffset >= 0)
		{	string	= null;

			if (parent.content.elementAt(start) instanceof String)
			{	string = (String) parent.content.elementAt(start);
			}
			else if (parent.content.elementAt(start) instanceof HTMLCText)
			{	string = ((HTMLCText) parent.content.elementAt(start)).toString();
			}
			
			if (string != null)
			{ this.text.append(string.substring(startoffset+1));
			}
			start ++;
		}

		for (pos = start; pos <= end; pos ++)
		{ if (pos == end && endoffset >= 0)
			{	break;
			}

			if (parent.content.elementAt(pos) instanceof String)
			{	this.text.append((String) parent.content.elementAt(pos));
			}
			else if (parent.content.elementAt(pos) instanceof HTMLCText)
			{	this.text.append(((HTMLCText) parent.content.elementAt(pos)).toString());
			}
			else if (parent.content.elementAt(pos) instanceof HTMLTag)
			{ // don't add it!
			}
		}

		if (pos == end && endoffset > 0)	// this deliberately ignore endoffset == 0
																		 	// 'cos nothing should happen anyhow!
		{	string	= null;

			if (parent.content.elementAt(pos) instanceof String)
			{	string = (String) parent.content.elementAt(pos);
			}
			else if (parent.content.elementAt(pos) instanceof HTMLCText)
			{	string = ((HTMLCText) parent.content.elementAt(pos)).toString();
			}
		
			if (string != null)
			{	this.text.append(string.substring(0, endoffset));
			}
		}
	}

	public String toString()
	{	if (this.text == null)
		{ return "";
		}
		return this.text.toString();
	}
}
