package org.greenstone.gsdl3.gs3build.util;



import java.util.*;



public class HTMLDocLocalHeading

{	String		heading;

	HTMLBlock	block;



	public HTMLDocLocalHeading(HTMLDoc doc, String local)

	{	HTMLBlock 				nextheading, lastheading, anchor;

		Enumeration				headings;

		HTMLDocAnchorList	anchors;

		HTMLBlock					docBlock;

		int								_start, _end, _pos;



		// initialise (to undefined)

		this.heading	= null;

		this.block		= null;



		// get anchors

		anchors	= new HTMLDocAnchorList(doc);

		anchor	= anchors.localAnchor(local);

		if (anchor == null)

		{	return;

		}



		// get headings position; lastheading will be previous, nextheading will be next

		headings		= doc.headings();

		lastheading	= null;

		nextheading	= null;



		while (headings.hasMoreElements())

		{	nextheading	= (HTMLBlock) headings.nextElement();

			if (nextheading.startPos() > anchor.startPos())

			{	break;

			}

			



			lastheading	= nextheading;

		}



		// didn't get any actual headings; abort.

		if (nextheading == null)

		{	return;

		}



		// got to the end

		if (nextheading == lastheading)

		{	this.block = nextheading;

		}

		else

		{	// now see where anchor is; try to find null textual content between anchor

			// and heading

			docBlock	= doc.getCodedContent();

			_start		= docBlock.find(anchor);

			_end			= docBlock.find(nextheading);

			for (_pos = _start; _pos < _end; _pos ++)

			{	// HTML tag

				if (docBlock.elementAt(_pos) instanceof HTMLTag)

				{	

				}

				// HTML text - if non-blank, abort

				else

				{	if (((HTMLCText) docBlock.elementAt(_pos)).nullString() == false)

					{	break;

					}

				}

			}



			// assign

			if (_pos != _end)

			{	this.block	=	lastheading;

			}

			else

			{	this.block	= nextheading;

			}

		}

		this.heading	= this.block.toString();

	}



	public String toString()

	{	return this.heading;

	}



	public HTMLBlock block()

	{	return this.block;

	}



	protected void finalize() throws Throwable

	{	this.heading	= null;

		this.block		= null;

		super.finalize();

	}

}